scala.tools.nsc.backend.icode.Linearizers

# NormalLinearizer

#### class NormalLinearizer extends ICodes.Linearizer with WorklistAlgorithm

A simple linearizer which predicts all branches to take the 'success' branch and tries to schedule those blocks immediately after the test. This is in sync with how 'while' statements are translated (if the test is 'true', the loop continues).

Source
  Linearizers.scala

Linear Supertypes
WorklistAlgorithm, ICodes.Linearizer, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. NormalLinearizer
2. WorklistAlgorithm
3. Linearizer
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new NormalLinearizer()

### Type Members

1. #### type Elem = ICodes.BasicBlock

   Definition Classes
     NormalLinearizer → WorklistAlgorithm

2. #### type WList = Stack[Elem]

   Definition Classes
     WorklistAlgorithm

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodes.NormalLinearizer to any2stringadd[ICodes.NormalLinearizer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodes.NormalLinearizer, B)

   Implicit information
     This member is added by an implicit conversion from ICodes.NormalLinearizer to ArrowAssoc[ICodes.NormalLinearizer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def add(bs: List[ICodes.BasicBlock]): Unit

7. #### def add(b: ICodes.BasicBlock): Unit

   Prepend b to the list, if not already scheduled.

   Prepend b to the list, if not already scheduled. TODO: use better test than linear search

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### var blocks: List[ICodes.BasicBlock]

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### def dequeue: Elem

    Remove and return the first element to be processed from the worklist.

    Remove and return the first element to be processed from the worklist.

    Definition Classes
      NormalLinearizer → WorklistAlgorithm

12. #### def ensuring(cond: (ICodes.NormalLinearizer) ⇒ Boolean, msg: ⇒ Any): ICodes.NormalLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to Ensuring[ICodes.NormalLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (ICodes.NormalLinearizer) ⇒ Boolean): ICodes.NormalLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to Ensuring[ICodes.NormalLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodes.NormalLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to Ensuring[ICodes.NormalLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): ICodes.NormalLinearizer

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to Ensuring[ICodes.NormalLinearizer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

19. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to StringFormat[ICodes.NormalLinearizer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

20. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

21. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

22. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

23. #### def linearize(startBlock: ICodes.BasicBlock): List[ICodes.BasicBlock]

    Linearize another subtree and append it to the existing blocks.

24. #### def linearize(m: ICodes.IMethod): List[ICodes.BasicBlock]

    Definition Classes
      NormalLinearizer → Linearizer

25. #### def linearizeAt(m: ICodes.IMethod, start: ICodes.BasicBlock): List[ICodes.BasicBlock]

    Definition Classes
      NormalLinearizer → Linearizer

26. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

27. #### final def notify(): Unit

    Definition Classes
      AnyRef

28. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

29. #### def processElement(b: ICodes.BasicBlock): Unit

    Process the current element from the worklist.

    Process the current element from the worklist.

    Definition Classes
      NormalLinearizer → WorklistAlgorithm

30. #### def run(initWorklist: ⇒ Unit): Unit

    Run the iterative algorithm until the worklist remains empty.

    Run the iterative algorithm until the worklist remains empty. The initializer is run once before the loop starts and should initialize the worklist.

    Definition Classes
      WorklistAlgorithm

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toString(): String

    Definition Classes
      AnyRef → Any

33. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### val worklist: WList

    Definition Classes
      NormalLinearizer → WorklistAlgorithm

37. #### def →[B](y: B): (ICodes.NormalLinearizer, B)

    Implicit information
      This member is added by an implicit conversion from ICodes.NormalLinearizer to ArrowAssoc[ICodes.NormalLinearizer] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from WorklistAlgorithm

### Inherited from ICodes.Linearizer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodes.NormalLinearizer to any2stringadd[ICodes.NormalLinearizer]

### Inherited by implicit conversion StringFormat from ICodes.NormalLinearizer to StringFormat[ICodes.NormalLinearizer]

### Inherited by implicit conversion Ensuring from ICodes.NormalLinearizer to Ensuring[ICodes.NormalLinearizer]

### Inherited by implicit conversion ArrowAssoc from ICodes.NormalLinearizer to ArrowAssoc[ICodes.NormalLinearizer]

### Ungrouped